<template>
  <div>
    <div class="alert alert-info" role="alert">
      Search and filter GitLab <a href="https://gitlab.com/gitlab-org/gitlab/-/blob/master/CHANGELOG.md">CHANGELOG</a> entries, annotated with Merge Request data for each change.
    </div>
    <div class="float-right">
      <csv-download
        class="btn btn-primary"
        :array="filteredChanges"
        :fields="[
          'version',
          'title',
          'description',
          'commit_url',
          'labels',
          'mr',
          'enterprise',
        ]"
        download="features_changes.csv"
      >
        Export as CSV
      </csv-download>
    </div>
    <div v-if="loading">Loading...</div>
    <template v-else>
      <form>
        <div class="form-row">
          <div class="form-group col-md-2">
            <label>Introduced after (including)</label>
            <multiselect
              v-model="minVersion"
              :options="allVersions"
              :customLabel="renderVersion"
              :allowEmpty="false"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Introduced before (including)</label>
            <multiselect
              v-model="maxVersion"
              :options="allVersions"
              :customLabel="renderVersion"
              :allowEmpty="false"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Category</label>
            <multiselect
              v-model="selectedCategories"
              :options="allCategories"
              :multiple="true"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Labels</label>
            <multiselect
              v-model="selectedLabels"
              :options="allLabels"
              :multiple="true"
              placeholder="Select one or multiple labels"
            />
          </div>
          <div class="form-group col-md3">
            <div class="form-check">
              <input
                class="form-check-input"
                type="checkbox"
                v-model="render_description"
                id="renderDescCheck"
              />
              <label class="form-check-label" for="renderDescCheck">
                Show MR Description
              </label>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
            title="Search supports regular expressions."
          >
            <label>Fulltext search</label>
            <input
              class="form-control"
              placeholder="Search feature name and description"
              v-model="textSearch"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Order By</label><br />
            <div class="btn-group" role="group" aria-label="Basic example">
              <select class="custom-select" v-model="orderKey">
                <option value="version">Version</option>
              </select>
              <button
                type="button"
                @click="order = order * -1"
                class="btn btn-outline-dark"
              >
                {{ order < 0 ? "Asc" : "Desc" }}
              </button>
            </div>
          </div>
        </div>
      </form>
      <paginated-table
        :items="filteredChanges"
        :total-items="changes.length"
        :per-page-default="500"
        tableClass="changelogTable"
      >
        <template v-slot:header>
          <tr>
            <th style="width: 5%">Version</th>
            <th style="width: 20%">Title</th>
            <th v-if="render_description" style="width: 35%">Description</th>
            <th>Category</th>
            <th style="width: 15%">Labels</th>
            <th>Merge Request</th>
            <th>Commit</th>
          </tr>
        </template>
        <template v-slot:row="{ item: change }">
          <td>{{ change.version }}</td>
          <td>{{ change.title }}</td>
          <td v-if="render_description" style="word-break:break-word"><span v-html="change.description"></span></td>
          <td>{{ change.category }}</td>
          <td>{{ (change.labels || []).join(", ") }}</td>
          <td>
            <a
              v-if="change.mr"
              :href="change.mr"
              target="_blank"
              >Merge Request</a>
          </td>
          <td>
            <a :href="change.commit_url" target="_blank">Commit</a>
          </td>
        </template>
      </paginated-table>
    </template>
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";
import PaginatedTable from "./components/paginated-table.vue";
import CsvDownload from "./components/csv-download.vue";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

let searchDefaults = {
  order: 1,
  orderKey: "version",
  selectedLabels: [],
  textSearch: "",
  minVersion: null,
  maxVersion: null,
  render_description: true,
  selectedCategories: [],
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

export default {
  components: {
    CsvDownload,
    PaginatedTable,
    Multiselect,
  },
  data() {
    return {
      data: [],
      loading: true,
      ...searchDefaults,
    };
  },
  async mounted() {
    const response = await fetch("./changelog.json");

    this.data = await response.json();
    const params = new URLSearchParams(window.location.search);

    searchDefaults.minVersion = this.allVersions[0];
    searchDefaults.maxVersion = this.allVersions.slice(-1)[0];

    this.minVersion = searchDefaults.minVersion;
    this.maxVersion = searchDefaults.maxVersion;

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });
    this.$parent.pageView({ page: "changelog" });
    this.loading = false;
  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }
      params.set("tab", "changelog");
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  methods: {
    renderVersion(version) {
      return version;
    }
  },
  computed: {
    allLabels() {
      return uniqAndSort(
        this.changes.map((change) => change.labels).flat()
      );
    },
    allCategories() {
      return uniqAndSort(
        this.changes.map((change) => change.category).flat()
      );
    },
    allVersions() {
      return uniqAndSort(
        this.changes.map((change) => change.version).flat()
      );
    },
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    changes() {
      return this.data.map((change) => {
        var commit_url = change.commit_url
        if(!commit_url.startsWith("https://gitlab.com/")) {
          commit_url = "https://gitlab.com/" + commit_url
        }
        
        //check if merge_request field exists. If not, set labels to empty array
        var labels = []
        var mr = ""
        var description = ""

        if(change.merge_request) {
          labels = change.merge_request.labels
          mr = change.merge_request.web_url
          description = change.merge_request.description
        }

        return {
            "title": change.title,
            "commit_url": commit_url,
            "version": change.version,
            "category": change.category,
            "enterprise": change.enterprise_edition,
            "labels": labels,
            "mr": mr,
            "description": description
          }
        
      });
    },
    filteredChanges() {
      return this.changes
        .filter((change) => {
          let visible = true;
          if (visible && this.maxVersion) {
            visible = visible && change.version <= this.maxVersion;
          }

          if (visible && this.minVersion) {
            visible = visible && change.version >= this.minVersion;
          }

          if (visible && this.selectedCategories.length) {
            visible =
              visible && this.selectedCategories.includes(change.category || null);
          }

          if (visible && this.selectedLabels.length) {
            var allMatches = false
            for(var i = 0; i < this.selectedLabels.length; i++) {
              if(change.labels.includes(this.selectedLabels[i])) {
                allMatches = true
              } else {
                allMatches = false
                break
              }
            }
            visible =
              visible &&
              allMatches
          }

          if (visible && this.textSearch) {
            const regex = new RegExp(this.searchLower, "gi");
            visible =
              visible &&
              (change.title.toLocaleLowerCase().includes(this.searchLower) ||
                change.description
                  .toLocaleLowerCase()
                  .includes(this.searchLower) ||
                  change.description.toLocaleLowerCase().match(regex));
          }
          return visible;
        })
        .sort((a, b) => {
          const valA = a[this.orderKey];
          const valB = b[this.orderKey];

          if (valA === valB) {
            return 0;
          }

          return (valB < valA ? -1 : 1) * this.order;
        });
    },
  },
};
</script>
